/***************************************************************************
 * project      : Cyberjack Diagnoses Tool
    begin       : Fri Jan 26 2007
    copyright   : (C) 2007 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *             This file is licensed under the GPL version 2.              *
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#include "cm_uname.h"

#include <sys/utsname.h>
#include <errno.h>
#include <string.h>



bool CM_Uname::check(std::string &xmlString,
		     std::string &reportString,
		     std::string &hintString) {
  struct utsname un;

  if (uname(&un)) {
    const char *s;

    s=strerror(errno);
    reportString+="*FEHLER* (";
    reportString+=s;
    reportString+=")\n";

    xmlString+="<check type=\"uname\">\n";
    xmlString+="  <result type=\"error\" function=\"uname\">";
    xmlString+=s;
    xmlString+="  </result>\n";
    xmlString+="</check>\n";

    return false;
  }

  /* create XML string */
  xmlString+="<check type=\"uname\">\n";
  xmlString+="  <result type=\"success\"></result>\n";
  xmlString+="  <systemname>";
  xmlString+=un.sysname;
  xmlString+="</systemname>\n";
  xmlString+="  <release>";
  xmlString+=un.release;
  xmlString+="</release>\n";
  xmlString+="  <version>";
  xmlString+=un.version;
  xmlString+="</version>\n";
  xmlString+="  <machine>";
  xmlString+=un.machine;
  xmlString+="</machine>\n";
  xmlString+="</check>\n";

  /* create report string */
  reportString+="System: ";
  reportString+=un.sysname;
  reportString+=", ";
  reportString+=un.release;
  reportString+=", ";
  reportString+=un.version;
  reportString+=", ";
  reportString+=un.machine;
  reportString+="\n";

  return true;
}





